import unit4.collectionsLib.*;
import unit4.utilsLib.*;

/**
 *   1    -  --   
 *
 * @author   ,   ,  , 
 * @version 26.11.2007
 */
public class BuildBalancedTreeFromSortedList
{
	public static void main(String[] args)
	{
		//      
		int n = (int)(Math.random()*20) + 1;
		List<Integer> lst = ListUtils.insertionSort(ListUtils.createRandomList(n, 0, 100));
		System.out.println(lst);
		
		//  :  - / 
        //    ,  ,  0
        //       -   
        BinTreeNode<Integer> bt = buildBT(n);
		BinTreeUtils.showTree(bt, "  ");
		
		//  :         
        //            --  
        InsertNumsIntoBT(bt, lst);
		BinTreeUtils.showTree(bt, "-- ");
	}
	
    // numNodes             
    public static BinTreeNode<Integer> buildBT(int numNodes)
    {
    	BinTreeNode<Integer> bt = new BinTreeNode<Integer>(0);
		Queue<BinTreeNode<Integer>> q = new Queue<BinTreeNode<Integer>>();
		q.insert(bt);
		
		for (int i = 2; i <= numNodes; i++)
		{
			if(q.head().getLeft() == null)
				q.head().setLeft(new BinTreeNode<Integer>(0));
			else
				if(q.head().getRight() == null)
				{
					q.head().setRight(new BinTreeNode<Integer>(0));
					q.insert(q.head().getLeft());
					q.insert(q.head().getRight());
					q.remove();
				}
		}
		
		return bt;
    }
    
    //          --
	public static void InsertNumsIntoBT(BinTreeNode<Integer> bt, List<Integer> lst)
	{
		if(bt != null)
		{
			InsertNumsIntoBT(bt.getLeft(), lst);
			bt.setInfo(lst.getFirst().getInfo());
			lst.remove(lst.getFirst());
			InsertNumsIntoBT(bt.getRight(), lst);
		}
	}
}
