import unit4.collectionsLib.*;

/**
 *   2    -       
 *
 * @author   ,   ,  , 
 * @version 26.11.2007
 */
public class Page 
{
	private String name;
	private List<Page> links;
	private int numOfLinks;
	
	public Page(String name)
	{
		this.name = name;
		this.links = new List<Page>();
		this.numOfLinks = 0;
	}
	
	public String getName()
	{
		return this.name;
	}
	
	public void addLink(Page link)
	{
		this.links.insert(null, link);
		this.numOfLinks++;
	}
	
	
	public Page[] getAllLinks()
	{
		Page[] allLinks = new Page[this.numOfLinks];
		Node<Page> pos = this.links.getFirst();
		int i=0;
		
		while(pos!=null)
		{
			allLinks[i] = pos.getInfo();
			i++;
			pos = pos.getNext();
		}
		
		return allLinks;
	}

	// ":  " 
	public boolean canGoTo(Page page)
	{
	  Queue<Page> q = new Queue<Page>();
	  
      q.insert(this);
      while (!q.isEmpty()) 
      {   
    	  Page p = q.remove();
    	  Page[] pages = p.getAllLinks();
          for (int i = 0; i < pages.length; i++)
          {
        	  if(page == pages[i])
        		  return true;
              	q.insert(pages[i]);
          }
      }
      return false;
	}

	public String toString()
	{
		if(this.numOfLinks==0)
			return("No links on this page!");
		
		String str = "Page " + this.name + " has " + this.numOfLinks + " links as follow:\n";
		Node<Page> pos = this.links.getFirst();
		
		while(pos!=null)
		{
			str = str + pos.getInfo().getName() + "\n";
			pos = pos.getNext();
		}
		
		return(str);
	}
}
